/* This code is provided under the terms of the 
 * MIT License, see at the end of the file
 * (c) 2013 Alejandro Paz
 
 
 
 
 
 
 a
 
 */



`timescale 1ns/100ps
`default_nettype none

`ifdef BCD_MATH
`define OP_ARITHM_ADDBCD  5'b00000
`define OP_ARITHM_ADDBIN  5'b00001
`define OP_ARITHM_ADCBCD  5'b00010
`define OP_ARITHM_ADCBIN  5'b00011
`define OP_ARITHM_SUBBCD  5'b00100
`define OP_ARITHM_SUBBIN  5'b00101
`define OP_ARITHM_SBCBCD  5'b00110
`define OP_ARITHM_SBCBIN  5'b00111

`define OP_ARITHM_AND     5'b01000
`define OP_ARITHM_OR      5'b01001
`define OP_ARITHM_NOT     5'b01010
`define OP_ARITHM_NAND    5'b01011
`define OP_ARITHM_XOR     5'b01100
`define OP_ARITHM_MOV     5'b01101
`define OP_ARITHM_MUL     5'b01110
`define OP_ARITHM_COMP9   5'b00111

`define OP_ARITHM_SHL     5'b10000
`define OP_ARITHM_SHR     5'b10001
`define OP_ARITHM_ROL     5'b10010
`define OP_ARITHM_ROR     5'b10011
`define OP_ARITHM_SHL4    5'b10100
`define OP_ARITHM_SHR4    5'b10101
`define OP_ARITHM_ROL4    5'b10110
`define OP_ARITHM_ROR4    5'b10111
`else

`define OP_ARITHM_ADDSAT  5'b00000
`define OP_ARITHM_ADDBIN  5'b00001
// empty slot
`define OP_ARITHM_ADCBIN  5'b00011
`define OP_ARITHM_SUBSAT  5'b00100
`define OP_ARITHM_SUBBIN  5'b00101
// empty slot
`define OP_ARITHM_SBCBIN  5'b00111

`define OP_ARITHM_AND     5'b01000
`define OP_ARITHM_OR      5'b01001
`define OP_ARITHM_NOT     5'b01010
`define OP_ARITHM_NAND    5'b01011
`define OP_ARITHM_XOR     5'b01100
`define OP_ARITHM_MOV     5'b01101
`define OP_ARITHM_MUL     5'b01110
`define OP_ARITHM_MULS    5'b01111


`define OP_ARITHM_SHL     5'b10000
`define OP_ARITHM_SHR     5'b10001
`define OP_ARITHM_ROL     5'b10010
`define OP_ARITHM_ROR     5'b10011
`define OP_ARITHM_MOV8SX  5'b10100
`define OP_ARITHM_MOV16SX 5'b10101
`define OP_ARITHM_SHR16   5'b10110
`define OP_ARITHM_ASR     5'b10111

`endif
`define OP_JUMP_JMP       5'b11000
`define OP_JUMP_DJNZ      5'b11001
`define OP_JUMP_TJNZ      5'b11010
`define OP_JUMP_TJZ       5'b11011
`define OP_XTRA_RDBYTE    5'b11100
`define OP_XTRA_WRBYTE    5'b11101
`define OP_XTRA_RDWORD    5'b11110
`define OP_XTRA_WRWORD    5'b11111

//`define TWO_THREADS  // uncomment for two-threads version
`define DSP_FUNCTIONS     500
`define LATTICE           500
/**
 *
 * Instruction encoding
 *          5                   3              3          1                  10                                         10
 * +---+---+---+---+---+ +---+---+---+ +----+----+----+ +---+ +---+---+---+---+---+---+---+---+---+  +---+---+---+---+---+---+---+---+---+---+
 * | O   O   O   O   O | | C   C   C | | wz | wc | wr | | i | |             D   R   E   G         |  |             S   R   E   G             |
 * +---+---+---+---+---+ +---+---+---+ +----+----+----+ +---+ +---+---+---+---+---+---+---+---+---+  +---+---+---+---+---+---+---+---+---+---+
 * 
 *       opcode            condition    write flags      imm
 * 
 * 
 * 
 */
`define BIT_I 20
`define FIELD_S 9:0
`define FIELD_D 19:10
`define RDELAY #5

/*
module tb_v8();

reg clk, reset;
wire sd_0, sd_1;

pnutdsp_v2_core core(
    .CLK_I(clk),
    .RESET_I(reset),
    .SD_0_O(sd_0),
	.SD_1_O(sd_1)
    );

always
    #50 clk =~clk;

initial
  begin
    $dumpvars;
    #0
    reset = 1;
    clk = 0;
    #5000
    $finish;
  end
  
endmodule
*/

module pnutdsp_top(
	SD_0_O,
	SD_1_O,
	DIN_O
	);

output SD_0_O, SD_1_O;
output [31:0] DIN_O;
`ifdef LATTICE
wire CLK_I, RESET_I, PUR_I;

defparam  iosc.NOM_FREQ="20.46";
OSCH iosc(.STDBY(1'b0), .OSC(CLK_I), .SEDSTDBY()); 
//GSR GSR_INST(.GSRNET(RESET_I));			
//PUR PUR_INST(.PURNET(PUR_I));

`endif


reg [3:0] rescnt;

always @(posedge CLK_I)
	if (rescnt[3] == 1'b0)
		rescnt <= rescnt + 1;

assign RESET_I = rescnt[3];

pnutdsp_v2_core(
    CLK_I,
    RESET_I,
    SD_0_O,
	SD_1_O,
	DIN_O
    );
 

endmodule

module pnutdsp_v2_core(
    CLK_I,
    RESET_I,
    SD_0_O,
	SD_1_O,
	DIN_O
    );
    
input CLK_I, RESET_I;
output SD_0_O, SD_1_O; /* sigmal delta outputs */
output [31:0] DIN_O;
wire internal_clk, internal_reset;

wire fetch_opcode_t1;
wire fetch_sd_t1;
wire tfr_sd_t1;
wire load_mult_t1;
wire wb_d_with_alu_t1;
wire wb_d_with_pcp1_t1;
wire wb_flags_t1;
wire wb_pc_with_pcp1_t1;
wire wb_pc_with_s_t1;
wire sd_0, sd_1; /* sigma delta outputs */
wire [31:0] opcode_t1, preopcode_t1;
wire [9:0] pc_plus_1_t1;

wire [31:0] data_d, data_s, alu_out, d_in;

reg [9:0] reg_pc_t1;
reg reg_c_t1, reg_z_t1;

wire flag_c, flag_z;
assign DIN_O = d_in;
`ifdef TWO_THREADS
wire fetch_opcode_t2;
wire fetch_sd_t2;
wire tfr_sd_t2;
wire load_mult_t2;
wire wb_d_with_alu_t2;
wire wb_d_with_pcp1_t2;
wire wb_flags_t2;
wire wb_pc_with_pcp1_t2;
wire wb_pc_with_s_t2;
wire [31:0] opcode_t2, preopcode_t2;
wire [9:0]  pc_plus_1_t2;
reg [9:0] reg_pc_t2;
reg reg_c_t2, reg_z_t2;


`endif

assign SD_0_O = sd_0;
assign SD_1_O = sd_1;
assign pc_plus_1_t1 = reg_pc_t1 + 9'h001;

`ifdef TWO_THREADS
assign pc_plus_1_t2 = reg_pc_t2 + 9'h001;
`endif
assign internal_clk = CLK_I;
assign internal_reset = RESET_I;

/* CALL logic
 * When a CALL is executed the return address (PC+1) is written to the
 * position of the RET instruction
 */

assign d_in = wb_d_with_pcp1_t1 ? { 22'b11000_111_000_0_0000000000, data_s[9:0] }: // JMP
`ifdef TWO_THREADS
              wb_d_with_pcp1_t2 ? { 22'b11000_111_000_0_0000000000, data_s[9:0] }: // JMP
`endif
              alu_out;

pnut_v8_seqencer seq(
    .CLK_I(internal_clk),
    .RESET_I(internal_reset),
    .OPCODE_T1_I(opcode_t1[31:20]),
    .FLAG_Z_T1_I(reg_z_t1), /* Flag Z input */
    .FLAG_C_T1_I(reg_c_t1), /* Flag C input */
    /* T 1 */
    .FETCH_OPCODE_T1_O(fetch_opcode_t1),
    .FETCH_SD_T1_O(fetch_sd_t1),
    .TFR_SD_T1_O(tfr_sd_t1),
	.LOAD_MULT_T1_O(load_mult_t1),
    .WRITEBACK_D_WITH_ALU_T1_O(wb_d_with_alu_t1),
    .WRITEBACK_D_WITH_PCP1_T1_O(wb_d_with_pcp1_t1),
    .WRITEBACK_FLAGS_T1_O(wb_flags_t1),
    .WRITEBACK_PC_WITH_PCP1_T1_O(wb_pc_with_pcp1_t1),
    .WRITEBACK_PC_WITH_S_T1_O(wb_pc_with_s_t1)
    
    /* T 2 */
`ifdef TWO_THREADS
	,
    .OPCODE_T2_I(opcode_t2[31:20]),
    .FLAG_Z_T2_I(reg_z_t2),
    .FLAG_C_T2_I(reg_c_t2),
    .FETCH_OPCODE_T2_O(fetch_opcode_t2),
    .FETCH_SD_T2_O(fetch_sd_t2),
    .TFR_SD_T2_O(tfr_sd_t2),
    .LOAD_MULT_T2_O(load_mult_t2),
    .WRITEBACK_D_WITH_ALU_T2_O(wb_d_with_alu_t2),
    .WRITEBACK_D_WITH_PCP1_T2_O(wb_d_with_pcp1_t2),
    .WRITEBACK_FLAGS_T2_O(wb_flags_t2),
    .WRITEBACK_PC_WITH_PCP1_T2_O(wb_pc_with_pcp1_t2),
    .WRITEBACK_PC_WITH_S_T2_O(wb_pc_with_s_t2)
`endif    
	);

pnut_v8_mem imem(
    .CLK_I(internal_clk),
	.RESET_I(internal_reset),
	
	.FETCH_OP_T1_I(fetch_opcode_t1),
	.LOAD_OP_T1_I(fetch_sd_t1),
	.FETCH_SD_T1_I(fetch_sd_t1),
	.TFR_SD_T1_I(tfr_sd_t1),
	.LOAD_MULT_T1_I(load_mult_t1),
	.WB_D_T1_I(wb_d_with_alu_t1 | wb_d_with_pcp1_t1),
	.D_I(d_in),
	.PC_T1_I(reg_pc_t1),
	.OPCODE_T1_O(opcode_t1),
	.PREOPCODE_T1_O(preopcode_t1),
	.D_O(data_d),
	.S_O(data_s),
	.SD_0_O(sd_0),
	.SD_1_O(sd_1)
	
`ifdef TWO_THREADS
    ,
	.FETCH_OP_T2_I(fetch_opcode_t2),
	.LOAD_OP_T2_I(fetch_sd_t2),
	.FETCH_SD_T2_I(fetch_sd_t2),
	.TFR_SD_T2_I(tfr_sd_t2),
	.LOAD_MULT_T2_I(load_mult_t2),
	.WB_D_T2_I(wb_d_with_alu_t2 | wb_d_with_pcp1_t2),
	.PC_T2_I(reg_pc_t2),
	.OPCODE_T2_O(opcode_t2),
	.PREOPCODE_T2_O(preopcode_t2)
`endif
	
	);
`ifdef BCD_MATH
bcd_bin_alu alu(
	s_in,
	d_in,
	c4_in,
	opcode_in,
	d_out,
	c4_out,
	z_out
	);
`else
bin_alu alu(
	.s_in(data_s),
	.d_in(data_d),
	.c_in(reg_c_t1),
	.opcode_in(opcode_t1[31:27]), // fixed for T1
	.d_out(alu_out),
	.c_out(flag_c),
	.z_out(flag_z)
	
);
`endif

/* Writeback handling of Program counter and flags */

always @(posedge internal_clk)
    begin
        if (wb_pc_with_pcp1_t1 == 1'b1) /* normal instructions */
            reg_pc_t1 <= pc_plus_1_t1;
        if (wb_pc_with_s_t1 == 1'b1) /* all jump kinds */
            reg_pc_t1 <= data_s[9:0];
`ifdef TWO_THREADS        
        if (wb_pc_with_pcp1_t2 == 1'b1) /* normal instructions */
            reg_pc_t2 <= pc_plus_1_t2;
        if (wb_pc_with_s_t2 == 1'b1) /* all jump kinds */
            reg_pc_t2 <= data_s[9:0];
`endif
    end    
	
initial
    begin
        reg_pc_t1 = 0;
        reg_c_t1 = 0;
        reg_z_t1 = 0;
`ifdef TWO_THREADS        
		reg_pc_t2 = 32;
        reg_c_t2 = 0; 
        reg_z_t2 = 0;
`endif
    end
endmodule /* top module */


module pnut_v8_seqencer(
    CLK_I,
    RESET_I,
    OPCODE_T1_I,
    FLAG_Z_T1_I,
    FLAG_C_T1_I,
    /* T 1 */
    FETCH_OPCODE_T1_O,
    FETCH_SD_T1_O,
    TFR_SD_T1_O,
	LOAD_MULT_T1_O,
    WRITEBACK_D_WITH_ALU_T1_O,
    WRITEBACK_D_WITH_PCP1_T1_O,
    WRITEBACK_FLAGS_T1_O,
    WRITEBACK_PC_WITH_PCP1_T1_O,
    WRITEBACK_PC_WITH_S_T1_O
    
    /* T 2 */
`ifdef TWO_THREADS
	,
    OPCODE_T2_I,
    FLAG_Z_T2_I,
    FLAG_C_T2_I,
    FETCH_OPCODE_T2_O,
    FETCH_SD_T2_O,
    TFR_SD_T2_O,
	LOAD_MULT_T2_O,
    WRITEBACK_D_WITH_ALU_T2_O,
    WRITEBACK_D_WITH_PCP1_T2_O,
    WRITEBACK_FLAGS_T2_O,
    WRITEBACK_PC_WITH_PCP1_T2_O,
    WRITEBACK_PC_WITH_S_T2_O
`endif
    );
 
input CLK_I, RESET_I;
input [11:0] OPCODE_T1_I;

input FLAG_Z_T1_I,
      FLAG_C_T1_I;
output reg FETCH_OPCODE_T1_O,
    FETCH_SD_T1_O,
    TFR_SD_T1_O,
	LOAD_MULT_T1_O,
    WRITEBACK_D_WITH_ALU_T1_O,
    WRITEBACK_D_WITH_PCP1_T1_O,
    WRITEBACK_FLAGS_T1_O,
    WRITEBACK_PC_WITH_PCP1_T1_O,
    WRITEBACK_PC_WITH_S_T1_O;

`ifdef TWO_THREADS	
input [11:0] OPCODE_T2_I;
input FLAG_Z_T2_I,
      FLAG_C_T2_I;
    /* T 2 */
output reg 	
    FETCH_OPCODE_T2_O,
    FETCH_SD_T2_O,
    TFR_SD_T2_O,
	LOAD_MULT_T2_O,
    WRITEBACK_D_WITH_ALU_T2_O,
    WRITEBACK_D_WITH_PCP1_T2_O,
    WRITEBACK_FLAGS_T2_O,
    WRITEBACK_PC_WITH_PCP1_T2_O,
    WRITEBACK_PC_WITH_S_T2_O;

reg t2_active;
`endif    
    
reg [3:0] state;

`define ST_COLD_RESET  0
`define ST_COLD_RESET1 1
`define ST_WARM_RESET  2
`define ST_T1_FETCH    3 /* only T1 fetches */
`define ST_T1_FETCH_SD 4 /* T1 fetches S&D from memory, saves opcode into reg */
`define ST_T2_WB       5
`define ST_T2_FETCH_SD 6
`define ST_T1_WB       7
`define T1_SEQ_OOO     OPCODE_T1_I[11:7]
`define T1_SEQ_CCC     OPCODE_T1_I[6:4]
`define T1_SEQ_Z       OPCODE_T1_I[5]
`define T1_SEQ_C       OPCODE_T1_I[4]
`define T1_SEQ_I       OPCODE_T1_I[0]

`ifdef TWO_THREADS
`define T2_SEQ_OOO     OPCODE_T2_I[11:7]
`define T2_SEQ_CCC     OPCODE_T2_I[6:4]
`define T2_SEQ_Z       OPCODE_T2_I[5]
`define T2_SEQ_C       OPCODE_T2_I[4]
`define T2_SEQ_I       OPCODE_T2_I[0]
`endif

wire t1_execute; /* is TRUE when the instruction has to be executed */

assign t1_execute = `T1_SEQ_CCC == 0 ? 1'b0:
                    `T1_SEQ_CCC < 3'h4 ? FLAG_Z_T1_I == `T1_SEQ_Z:
                    `T1_SEQ_CCC == 3'h7 ? 1'b1:FLAG_C_T1_I == `T1_SEQ_C;
`ifdef TWO_THREADS
wire t2_execute; /* because the flags allow it or they are not tested */
assign t2_execute = `T2_SEQ_CCC == 0 ? 1'b0:
                    `T2_SEQ_CCC < 3'h4 ? FLAG_Z_T2_I == `T2_SEQ_Z:
                    `T2_SEQ_CCC == 3'h7 ? 1'b1:FLAG_C_T2_I == `T2_SEQ_C;
`endif
always @(posedge CLK_I)
	begin
		if (RESET_I == 1'b0)
			state <= 3'b000;
		else
			begin
				if (state[2] == 1'b1)
					state[1:0] <= `RDELAY state + 2'b01;
				else
					state <= `RDELAY state + 3'b01;
`ifdef TWO_THREADS
				if (state[2:0] == 3'b111)
				    t2_active <= 1'b1;
`endif
			end
	end

always @(*)
    begin
        #5
        FETCH_OPCODE_T1_O            = 1'b0;
        FETCH_SD_T1_O                = 1'b0;
        TFR_SD_T1_O                  = 1'b0;
        WRITEBACK_D_WITH_ALU_T1_O    = 1'b0;
        WRITEBACK_D_WITH_PCP1_T1_O   = 1'b0;
        WRITEBACK_FLAGS_T1_O         = 1'b0;
        WRITEBACK_PC_WITH_PCP1_T1_O  = 1'b0;
        WRITEBACK_PC_WITH_S_T1_O     = 1'b0;
		LOAD_MULT_T1_O               = 1'b0;
        case (state)
            `ST_COLD_RESET: begin end
			`ST_COLD_RESET1: begin end			
			`ST_WARM_RESET: begin end
			`ST_T1_FETCH:
				FETCH_OPCODE_T1_O = 1'b1;
			`ST_T1_FETCH_SD: /* 4 */
				begin
					FETCH_SD_T1_O = 1'b1;
				end
			`ST_T2_WB: /* 5 */
			    begin
			        TFR_SD_T1_O = 1'b1; // save fetched S&D to temporal registers
					case (`T1_SEQ_OOO)
			            `OP_ARITHM_MULS: // handle MULS
			                begin
			                    LOAD_MULT_T1_O = 1'b1;
			                end
			        endcase
			    end
			`ST_T2_FETCH_SD:
			    begin
			        // process jumps, in the next cycle the opcode will be fetched
			        if (t1_execute == 1'b1)
						case (`T1_SEQ_OOO)
							`OP_JUMP_JMP: // JMP or CALL
									WRITEBACK_PC_WITH_S_T1_O = 1'b1;
							default:
								WRITEBACK_PC_WITH_PCP1_T1_O = 1'b1;
						endcase
					else
						WRITEBACK_PC_WITH_PCP1_T1_O = 1'b1; // skip
			    end
			`ST_T1_WB:
			    begin
			        /* T1, write back  */
			        FETCH_OPCODE_T1_O = 1'b1;
			        
			        if (t1_execute)
			            case (`T1_SEQ_OOO)
			                `OP_JUMP_JMP:
			                    begin
			                        if (`T1_SEQ_I == 1'b0) // not set, it's a call, write PC+1 to [d]
			                            begin
			                                WRITEBACK_D_WITH_PCP1_T1_O = 1'b1;
			                            end
			                    end
							default:
							    begin
							        WRITEBACK_D_WITH_ALU_T1_O = 1'b1;
							        WRITEBACK_FLAGS_T1_O = 1'b1;
							    end
			            endcase
			    end
		endcase
		
`ifdef TWO_THREADS
        /* T 2 */
        FETCH_OPCODE_T2_O            = 1'b0;
        FETCH_SD_T2_O                = 1'b0;
        TFR_SD_T2_O                  = 1'b0;
        WRITEBACK_D_WITH_ALU_T2_O    = 1'b0;
        WRITEBACK_D_WITH_PCP1_T2_O   = 1'b0;
        WRITEBACK_FLAGS_T2_O         = 1'b0;
        WRITEBACK_PC_WITH_PCP1_T2_O  = 1'b0;
        WRITEBACK_PC_WITH_S_T2_O     = 1'b0;
		LOAD_MULT_T2_O               = 1'b0;
        case (state)
            `ST_COLD_RESET: begin end
			`ST_COLD_RESET1: begin end			
			`ST_WARM_RESET: begin end
			`ST_T1_FETCH:
				FETCH_OPCODE_T1_O = 1'b1;
			`ST_T1_FETCH_SD: /* 4 */
				begin
					if (t2_active)
					    begin
							if (t2_execute == 1'b1)
								case (`T1_SEQ_OOO)
									`OP_JUMP_JMP: // JMP or CALL
										WRITEBACK_PC_WITH_S_T2_O = 1'b1;
									default:
										WRITEBACK_PC_WITH_PCP1_T2_O = 1'b1;
								endcase
							else
								WRITEBACK_PC_WITH_PCP1_T2_O = 1'b1; // skip
			            end
				end
			`ST_T2_WB: /* 5 */
			    begin
			        /* T2, write back  */
			        FETCH_OPCODE_T2_O = 1'b1;
			        if (t2_execute && t2_active)
			            case (`T2_SEQ_OOO)
			                `OP_JUMP_JMP:
			                    begin
			                        WRITEBACK_PC_WITH_S_T2_O = 1'b1;
			                        if (`T2_SEQ_I == 1'b0) // not set, it's a call, write PC+1 to [d]
			                            begin
			                                WRITEBACK_D_WITH_PCP1_T2_O = 1'b1;
			                                //WRITEBACK_PC_WITH_S_T2_O = 1'b1;
			                            end
			                    end
							default:
							    begin
							        WRITEBACK_D_WITH_ALU_T2_O = 1'b1;
							        WRITEBACK_FLAGS_T2_O = 1'b1;
							    end
			            endcase
			                
			    end
			`ST_T2_FETCH_SD:
			    begin
			        FETCH_SD_T2_O = 1'b1;
			    end
			`ST_T1_WB:
			    begin
			       TFR_SD_T2_O = 1'b1; // save fetched S&D to temporal registers
				   case (`T2_SEQ_OOO)
			            `OP_ARITHM_MULS: // handle MULS
			                begin
			                    LOAD_MULT_T2_O = 1'b1;
			                end
			        endcase
			    end
		endcase
`endif
	end

initial
    state = 0;
	
endmodule
			
module pnut_v8_mem(
	CLK_I,
	RESET_I,
	
	FETCH_OP_T1_I,
	LOAD_OP_T1_I,
	FETCH_SD_T1_I,
	TFR_SD_T1_I,
	WB_D_T1_I,
	D_I,
	PC_T1_I,
	LOAD_MULT_T1_I,
	OPCODE_T1_O,
	PREOPCODE_T1_O,
	
`ifdef TWO_THREADS	
	FETCH_OP_T2_I,
	LOAD_OP_T2_I,
	FETCH_SD_T2_I,
	TFR_SD_T2_I,
	WB_D_T2_I,
	PC_T2_I,
	LOAD_MULT_T2_I,
	OPCODE_T2_O,
	PREOPCODE_T2_O,
`endif	
	D_O,
	S_O,
	SD_0_O,
	SD_1_O
	);

input CLK_I, /* main clock, rising edge used to load registers */
	RESET_I,   
	FETCH_OP_T1_I, /* fetch from memory opcode */
	LOAD_OP_T1_I, /* signals when the opcode register has to be loaded with the value from memory */
	FETCH_SD_T1_I,
	TFR_SD_T1_I,
	WB_D_T1_I,
	LOAD_MULT_T1_I;
input [31:0] D_I;
input [9:0] PC_T1_I;
output [31:0] OPCODE_T1_O, PREOPCODE_T1_O;
output [31:0] S_O, D_O;
output SD_0_O, // sigma delta encoder 0 output
	   SD_1_O; // sigma delta encoder 1 output
wire [31:0] mult_res_t1;

`ifdef TWO_THREADS
input FETCH_OP_T2_I,
	FETCH_SD_T2_I,
	LOAD_OP_T2_I,/* signals when the opcode register has to be loaded with the value from memory */
	TFR_SD_T2_I,
	WB_D_T2_I,
	LOAD_MULT_T2_I;
input [9:0] PC_T2_I;
output [31:0] OPCODE_T2_O, PREOPCODE_T2_O;
wire [31:0] mult_res_t2;
`endif

/* Addresses for d and s are taken directly from the opcode */
wire [9:0] port_a_addr, port_b_addr;
wire [31:0] port_a_bus, port_b_bus;

wire WB_D;

reg	[31:0] opcode_t1_r, opcode_t2_r;
reg [31:0] d_r, s_r;

assign D_O = d_r; /* one for both threads */
assign S_O = s_r;
assign OPCODE_T1_O = opcode_t1_r;
assign PREOPCODE_T1_O = port_a_bus;
wire rd_en_a;

`ifdef TWO_THREADS
assign OPCODE_T2_O = opcode_t2_r;
assign PREOPCODE_T2_O = port_a_bus;
assign WB_D = WB_D_T1_I | WB_D_T2_I;
assign rd_en_a = FETCH_OP_T1_I | FETCH_OP_T2_I | FETCH_SD_T1_I | FETCH_SD_T2_I;
`else
assign WB_D = WB_D_T1_I;
assign rd_en_a = FETCH_OP_T1_I | FETCH_SD_T1_I;

`endif

reg [31:0] cnt_r, sd_cnt_r, sd_period_r;
reg [15:0] sd_idata0_r, sd_data0_r, sd_idata1_r, sd_data1_r;
reg [9:0] ptr0_t1_r, ptr1_t1_r;

`ifdef TWO_THREADS
reg [9:0] ptr0_t2_r, ptr1_t2_r;
`endif

`ifdef LATTICE
iram_1k_32 imem(.DataInA(), .DataInB(D_I), .AddressA(port_a_addr), 
                .AddressB(port_b_addr), 
                .ClockA(CLK_I), .ClockB(CLK_I), 
                .ClockEnA(1'b1), .ClockEnB(1'b1), .WrA(1'b0), .WrB(WB_D), 
				.ResetA(RESET_I), .ResetB(RESET_I), .QA(port_a_bus), .QB(port_b_bus));

`else
memblock_dp_x32 imem(
	.clk_i(CLK_I),
	.port_a_addr_i(port_a_addr),
	.port_b_addr_i(port_b_addr),
	.port_c_addr_i(port_b_addr),
	.port_a_rden_i(rd_en_a),
`ifdef TWO_THREADS 
	.port_b_rden_i(FETCH_SD_T1_I | FETCH_SD_T2_I),
`else
	.port_b_rden_i(FETCH_SD_T1_I),
`endif
	.port_a_q_o(port_a_bus),
	.port_b_q_o(port_b_bus),
	.port_c_wen_i(WB_D),
	.port_c_data_i(D_I)
	);
`endif

boothmult mult_t1(
	.clk_i(CLK_I),
	.en_i(LOAD_MULT_T1_I),
	.m_i(port_a_bus[15:0]),
	.r_i(port_b_bus[15:0]),
	.r_o(mult_res_t1)
	);
`ifdef TWO_THREADS
boothmult mult_t2(
	.clk_i(CLK_I),
	.en_i(LOAD_MULT_T2_I),
	.m_i(port_a_bus[15:0]),
	.r_i(port_b_bus[15:0]),
	.r_o(mult_res_t2)
	);
`endif

sd_modulator sd0(
	.CLK(CLK_I),
	.RESET(RESET_I),
	.ANALOG_I(sd_idata0_r),
	.SD_OUT(SD_0_O)
	);

sd_modulator sd1(
	.CLK(CLK_I),
	.RESET(RESET_I),
	.ANALOG_I(sd_idata1_r),
	.SD_OUT(SD_1_O)
	);
/* Internal registers 
 *
 * 3F0  32 bit counter 
 * 3F1  Multiplier result (one per thread)
 * 3F2
 * 3F3
 * 3F4  SD Data 0
 * 3F5  SD Data 1
 * 3F6  SD period in clocks
 * 3F7  SD counter, resetted when equal to [3F6]
 * 3F8  Pointer 0, set (one per thread)
 * 3F9  Pointer 0, autoincremented when read (one per thread)
 * 3FA  Pointer 1, set (one per thread)
 * 3FB  Pointer 1, autoincremented when read (one per thread)
 */



assign port_a_addr = FETCH_OP_T1_I == 1'b1 ? PC_T1_I:
					 (FETCH_SD_T1_I == 1'b1) && (port_a_bus[9:1] == 9'h1fc) ? ptr0_t1_r: // indirect access
					 (FETCH_SD_T1_I == 1'b1) && (port_a_bus[9:1] == 9'h1fd) ? ptr1_t1_r: // indirect access
`ifdef TWO_THREADS
                     FETCH_OP_T2_I == 1'b1 ? PC_T2_I:
					 (FETCH_SD_T2_I == 1'b1) && (port_a_bus[9:1] == 9'h1fc) ? ptr0_t2_r: // indirect access
					 (FETCH_SD_T2_I == 1'b1) && (port_a_bus[9:1] == 9'h1fd) ? ptr1_t2_r: // indirect access
`endif
                     port_a_bus[9:0]; /* field s of opcode */
assign port_b_addr = WB_D_T1_I == 1'b1 ? (opcode_t1_r[19:10] == 10'h3f9) ? ptr0_t1_r: 
                                         (opcode_t1_r[19:10] == 10'h3f9) ? ptr0_t1_r:opcode_t1_r[19:10]:
					 (FETCH_SD_T1_I == 1'b1) && (port_a_bus[19:11] == 9'h1fc) ? ptr0_t1_r: // indirect access
					 (FETCH_SD_T1_I == 1'b1) && (port_a_bus[19:11] == 9'h1fd) ? ptr1_t1_r: // indirect access
`ifdef TWO_THREADS
                     WB_D_T2_I == 1'b1 ? (opcode_t2_r[19:10] == 10'h3f9) ? ptr0_t2_r: 
                                         (opcode_t2_r[19:10] == 10'h3f9) ? ptr0_t2_r:opcode_t2_r[19:10]:
					 (FETCH_SD_T2_I == 1'b1) && (port_a_bus[19:11] == 9'h1fc) ? ptr0_t2_r: // indirect access
					 (FETCH_SD_T2_I == 1'b1) && (port_a_bus[19:11] == 9'h1fd) ? ptr1_t2_r: // indirect access
`endif
                     port_a_bus[19:10]; /* field d of opcode */

always @(posedge CLK_I)
	begin
		if (LOAD_OP_T1_I == 1'b1)
			opcode_t1_r <= port_a_bus;
`ifdef TWO_THREADS
		if (LOAD_OP_T2_I == 1'b1)
			opcode_t2_r <= port_a_bus;
		if (TFR_SD_T2_I == 1'b1)
			begin
		        if (opcode_t2_r[`BIT_I] == 1'b1) /* immediate argument */
		            s_r <= { 22'h0, opcode_t2_r[`FIELD_S] };
		        else
					case (opcode_t2_r[`FIELD_S])
						10'h3F0: s_r <= cnt_r; // gets cycle counter
						10'h3F1: s_r <= mult_res_t1;
						10'h3F4: s_r <= sd_data0_r;
						10'h3F5: s_r <= sd_data1_r;
						default:
							s_r <= port_a_bus;
					endcase
		            
				case (opcode_t2_r[`FIELD_D])
					10'h3F0: d_r <= cnt_r; // gets cycle counter
					10'h3F1: d_r <= mult_res_t1;
					10'h3F4: d_r <= sd_data0_r;
					10'h3F5: d_r <= sd_data1_r;
					default:
						d_r <= port_b_bus;
				endcase
		    end
`endif
		if (TFR_SD_T1_I == 1'b1) /* read */
		    begin
		        if (opcode_t1_r[`BIT_I] == 1'b1) /* immediate argument */
		            s_r <= { 22'h0, opcode_t1_r[`FIELD_S] };
		        else
					case (opcode_t1_r[`FIELD_S])
						10'h3F0: s_r <= cnt_r; // gets cycle counter
						10'h3F1: s_r <= mult_res_t1;
						10'h3F4: s_r <= sd_data0_r;
						10'h3F5: s_r <= sd_data1_r;
						10'h3f8: s_r <= ptr0_t1_r;
						10'h3f9:
							begin
								ptr0_t1_r <= ptr0_t1_r + 1; // reads from memory at ptr1
								s_r <= port_a_bus; /* reads current memory */
							end
						10'h3fa: s_r <= ptr0_t1_r;
						10'h3fb:
							begin
								ptr1_t1_r <= ptr1_t1_r + 1; // reads from memory at ptr1
								s_r <= port_a_bus; /* reads current memory */
							end
						default:
							s_r <= port_a_bus;
					endcase
		            
				case (opcode_t1_r[`FIELD_D])
					10'h3F0: d_r <= cnt_r; // gets cycle counter
					10'h3F1: d_r <= mult_res_t1;
					10'h3F4: d_r <= sd_data0_r;
					10'h3F5: d_r <= sd_data1_r;
					10'h3f8: s_r <= ptr0_t1_r;
					10'h3f9:
						begin
							// it shouldn't be incremented here, but at the write
							//ptr0_t1_r <= ptr0_t1_r + 1; // reads from memory at ptr1
							d_r <= port_a_bus; /* reads current memory */
						end
					10'h3fa: s_r <= ptr0_t1_r;
					10'h3fb:
						begin
							// it shouldn't be incremented here, but at the write
							//ptr1_t1_r <= ptr1_t1_r + 1; // reads from memory at ptr1
							d_r <= port_a_bus; /* reads current memory */
						end	
					default:
						d_r <= port_b_bus;
				endcase
		    end
		if (WB_D == 1'b1) /* write to port */
			begin
				case (opcode_t1_r[`FIELD_D])
					10'h3F4: sd_data0_r <= D_I[15:0];
					10'h3F5: sd_data1_r <= D_I[15:0];
					10'h3F6: sd_period_r <= D_I[15:0];
					10'h3F7: sd_cnt_r <= D_I[15:0];
					10'h3f8: ptr0_t1_r <= D_I[9:0];
					10'h3fa: ptr1_t1_r <= D_I[9:0];
				endcase
			end
		
		/* Port logic */
		cnt_r <= cnt_r + 1;
		if (sd_cnt_r == sd_period_r)
			begin
				sd_cnt_r <= 0;
				// set new output
				sd_idata0_r <= sd_data0_r; /* loads new value */
				sd_idata1_r <= sd_data1_r; /* loads new value */
			end
		else
			if (sd_period_r != 0) /* only counts if period != 0 */
				sd_cnt_r <= sd_cnt_r + 1;
			
	end

initial
	begin
		cnt_r  = 0;
		sd_cnt_r = 0;
		sd_period_r = 0;
		sd_data0_r = 0;
		sd_data1_r = 0;
	end
endmodule

/* Modulates sigma-delta the given 16 bit signed value ANALOG_I */
module sd_modulator(
	CLK,
	RESET,
	ANALOG_I,
	SD_OUT
	);
	
input CLK, RESET;
input [15:0] ANALOG_I;
output SD_OUT;

reg [15:0] sd_acc;
reg r_sd_out;

assign SD_OUT = r_sd_out;

wire [16:0] sd_diff, sd_add, sd_ddc;

assign sd_ddc = sd_acc[15] == 1'b1 ? 16'h8000:16'h7fff;
assign sd_diff = ANALOG_I + sd_ddc;
assign sd_add = sd_diff + sd_acc;

always @(posedge CLK)
	begin
		if (RESET == 1'b1)
			begin
				sd_acc <= 0;
			end
		else
			begin
				// sigma delta
				sd_acc <= sd_add;
				
				if (sd_acc < ANALOG_I) // negative
					begin
						r_sd_out <= 1;
					end
				else
					begin
						r_sd_out <= 0;
					end
				
			end
	end

endmodule
`ifndef LATTICE
module memblock_dp_x32(
	clk_i,
	port_a_addr_i,
	port_b_addr_i,
	port_c_addr_i,
	port_a_rden_i,
	port_b_rden_i,
	port_a_q_o,
	port_b_q_o,
	port_c_wen_i,
	port_c_data_i
	);

input [9:0] port_a_addr_i, port_b_addr_i, port_c_addr_i;
input clk_i, port_a_rden_i, port_b_rden_i, port_c_wen_i;
input [31:0] port_c_data_i;
output reg [31:0] port_a_q_o, port_b_q_o;

reg [31:0] mem[1023:0];

always @(posedge clk_i)
	begin
		if (port_a_rden_i)
			port_a_q_o <= mem[port_a_addr_i];
		if (port_b_rden_i)
			port_b_q_o <= mem[port_b_addr_i];
		if (port_c_wen_i)
			mem[port_c_addr_i] <= port_c_data_i;
	end
integer i;
initial
	begin
		#0
        for (i = 0; i < 1024; i = i+1)
            mem[i] = 0;
		//               op   CCC WWW      631        src
		//                     CZ ZCR i   84268421   84218421
		mem[   0] = 32'b01101_111_001_1_1111111000_0000100000; // mov $3f8, $20
		mem[   1] = 32'b00000_111_001_0_0001100000_1111111001; // addsat $30, [$3f8++]
		mem[   2] = 32'b10110_111_001_0_0001100001_0000100010; // mov    $31, $22
		mem[   3] = 32'b00100_111_001_0_0001100001_0000100001; // subsat $31, $21
		mem[   4] = 32'b01010_111_001_0_0001000100_1111110100; // sub rt, rt2 wc
		mem[   5] = 32'b01010_111_001_0_0001000001_1111110100; // andn rA2, mask
		mem[   6] = 32'b01010_111_001_0_0001000011_0001000110; // andn rB2, mask
		mem[   7] = 32'b11000_011_000_1_0000000000_0000010000; // jz  #add
		mem[   8] = 32'b00101_111_110_1_0001000100_0000010000; // cmp rt, #16 
		mem[   9] = 32'b11000_100_000_1_0000000000_0000010000; // jnc #20
		mem[  10] = 32'b10101_111_011_0_0001000010_0001000010; // shr4 rB, rB
		mem[  11] = 32'b10111_111_001_0_0001000011_0001000011; // ror4 rB2, rB2
		mem[  12] = 32'b00000_000_000_0_0000000000_0000000000;
		mem[  13] = 32'b00000_000_000_0_0000000000_0000000000;
		mem[  14] = 32'b00000_000_000_0_0000000000_0000000000;
		mem[  15] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h10] = 32'b00000_000_001_0_0001010000_0001010000;
		mem['h11] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h12] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h13] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h14] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h15] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h16] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h17] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h18] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h19] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h1a] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h1b] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h1c] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h1d] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h1e] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h1f] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h20] = 32'b00000_000_000_0_0000000000_0000000011;
		mem['h21] = 32'b01000_000_000_0_0000000000_0000001011;
		mem['h22] = 32'b11000_000_000_0_0000000000_0000000001;
		mem['h23] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h24] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h25] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h26] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h27] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h28] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h29] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h2a] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h2b] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h2c] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h2d] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h2e] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h2f] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h30] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h31] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h32] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h33] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h34] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h35] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h36] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h37] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h38] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h39] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h3a] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h3b] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h3c] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h3d] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h3e] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h3f] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h40] = 32'h09876543; // 32'b00000_000_000_0_0000000000_0000000000;
		mem['h41] = 32'h21098817; // 32'b00000_000_000_0_0000000000_0000000000;
		mem['h42] = 32'h05454545; // 32'b00000_000_000_0_0000000000_0000000000;
		mem['h43] = 32'h03232816; // 32'b00000_000_000_0_0000000000_0000000000;
		mem['h44] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h45] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h46] = 32'h00000fff; // 32'b00000_000_000_0_0000000000_0000000000;
		mem['h47] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h48] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h49] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h4a] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h4b] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h4c] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h4d] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h4e] = 32'b00000_000_000_0_0000000000_0000000000;
		mem['h4f] = 32'b00000_000_000_0_0000000000_0000000000;
		
	end
endmodule
`endif
/* Booth's multiplication algorithm */
/* multiplies 16x16 in 16 clocks */
module boothmult(
	clk_i,
	en_i,
	m_i,
	r_i,
	r_o
	);
parameter IBITS = 32;
`define PBITS 16
`define PBITSM1 15
input clk_i, en_i;
input [15:0] m_i, r_i;
output [31:0] r_o;

reg [32:0] A, S, P;
reg [3:0] cnt;
wire [32:0] PPA, PSA;
wire [15:0] neg_m;

assign PPA = P + A;
assign PSA = P + S;
assign r_o = P[32:1];
assign neg_m = `PBITS'h0-m_i[`PBITSM1:0];

always @(posedge clk_i)
	begin
		if (en_i == 1'b1)
			begin
				A <= { m_i, `PBITS'h0, 1'b0 };
				S <= { neg_m, `PBITS'h0, 1'b0 };
				//P <= { `PBITS'h0, r_i[`PBITSM1:0], 1'h0 };
				if (r_i[0] == 1'b0) // just shift
					P <= { `PBITS'h0, 1'h0, r_i[`PBITSM1:0] };
				else
					P <= { neg_m[15], neg_m, r_i[`PBITSM1:0] };
				cnt <= 4'd15;
			end
		else
			if (cnt > 0)
				begin
					case (P[1:0])
						2'b00: P <= { P[IBITS], P[IBITS:1] };
						2'b01: P <= { PPA[IBITS], PPA[IBITS:1] };
						2'b10: P <= { PSA[IBITS], PSA[IBITS:1] };
						2'b11: P <= { P[IBITS], P[IBITS:1] };
					endcase
					$display("%08x %08x %09x %09x = %09x %08x %2d", m_i, r_i, A, S, P, P[IBITS:1], cnt);
					cnt <= cnt - 4'd1;
				end
	end
	
initial
	cnt = 0;
	
endmodule

/* 32 bit ALU
 *
 */
`ifdef BCD_MATH
module bcd_bin_alu(
	s_in,
	d_in,
	c4_in,
	opcode_in,
	d_out,
	c4_out,
	z_out
	);

input [31:0] s_in, d_in;
input [3:0] c4_in;
input [4:0] opcode_in;
output [31:0] d_out;
output [3:0] c4_out;
output z_out;

reg z_out;
reg [31:0] d_out;
reg [3:0] c4_out;

wire [31:0] addbcd_o, subbcd_o;

wire addbcd_c_o, subbcd_c_o;
reg int_carry, int_z;

addbcd32 addbcd32 (s_in, d_in, int_carry, addbcd_o, addbcd_c_o);

/* BCD Subtraction */

subbcd32 subbbcd32(s_in, d_in, int_carry, subbcd_o, subbcd_c_o);


always @(*)
	begin
		z_out = d_out == 32'h0;
		int_carry = 1'b0;
		c4_out = c4_in; /* unless explicitly modified */
		case (opcode_in)
			`OP_ARITHM_ADDBCD:
				begin
					d_out = addbcd_o;
					c4_out[0] = addbcd_c_o;
				end
			`OP_ARITHM_ADDBIN:
				{ c4_out[0], d_out } = { 1'b0, s_in } + { 1'b0, d_in };
			`OP_ARITHM_AND:
				d_out = s_in & d_in;
			`OP_ARITHM_OR:
				d_out = s_in | d_in;
			`OP_ARITHM_SUBBCD:
				begin
					d_out = subbcd_o;
					c4_out[0] = subbcd_c_o;
				end
			`OP_ARITHM_SUBBIN:
				{ c4_out[0], d_out } = { 1'b0, d_in } - { 1'b0, s_in };
			`OP_ARITHM_NOT:
				d_out = ~s_in;
			`OP_ARITHM_COMP9:
				d_out = ~s_in; // not right
			`OP_ARITHM_ADCBCD:
				begin
					int_carry = c4_in[0];
					d_out = addbcd_o;
					c4_out[0] = addbcd_c_o;
				end
			`OP_ARITHM_ADCBIN:
				{ c4_out[0], d_out } = { 1'b0, s_in } + { 1'b0, d_in } + { 32'h0, c4_in[0] };
			`OP_ARITHM_NAND:
				d_out = d_in & (~s_in);
			`OP_ARITHM_XOR:
				d_out = s_in ^ d_in;
			`OP_ARITHM_SBCBCD:
				begin
					int_carry = c4_in[0];
					d_out = subbcd_o;
					c4_out[0] = subbcd_c_o;
				end
			`OP_ARITHM_SBCBIN:
				{ c4_out[0], d_out } = { 1'b0, d_in } - { 1'b0, s_in } - { 32'h0, c4_in[0] };
			`OP_ARITHM_MOV:
				d_out = s_in;
			`OP_ARITHM_MUL:
				d_out = s_in[7:0] * d_in[7:0];
			`OP_ARITHM_SHL:
				{ c4_out[0], d_out } = { s_in, 1'b0 };
			`OP_ARITHM_SHR:
				begin
					c4_out[0] = s_in[0];
					d_out = { 1'b0, s_in[31:1] };
				end
			`OP_ARITHM_ROL:
				begin
					c4_out[0] = s_in[31];
					d_out = { s_in[30:0], c4_in[0] };
				end
			`OP_ARITHM_ROR:
				begin
					c4_out[0] = s_in[0];
					d_out = { c4_in, s_in[31:1] };
				end
			`OP_ARITHM_SHL4:
				begin
					c4_out = s_in[31:28];
					d_out = { s_in[27:0], 4'h0 };
				end
			`OP_ARITHM_SHR4:
				begin
					c4_out = s_in[3:0];
					d_out = { 4'h0, s_in[31:4] };
				end
			`OP_ARITHM_ROL4:
				begin
					c4_out = s_in[31:28];
					d_out = { s_in[27:0], c4_in };
				end
			`OP_ARITHM_ROR4:
				begin
					c4_out = s_in[3:0];
					d_out = { c4_in, s_in[31:4] };
				end
			`OP_JUMP_DJNZ:
				d_out = d_in - 1;
			`OP_JUMP_TJNZ,
			`OP_JUMP_TJZ:
				z_out = d_in == 32'h0;
		endcase
	end

endmodule
`else

module bin_alu(
	s_in,
	d_in,
	c_in,
	opcode_in,
	d_out,
	c_out,
	z_out
	);

input [31:0] s_in, d_in;
input c_in;
input [4:0] opcode_in;
output [31:0] d_out;
output c_out;
output z_out;

reg z_out;
reg [31:0] d_out;
reg  c_out;

wire [32:0] add_o, sub_o;
assign add_o = { 1'b0, s_in } + { 1'b0, d_in };
assign sub_o = { 1'b0, s_in } - { 1'b0, d_in };

reg int_carry, int_z;

always @(*)
	begin
		z_out = d_out == 32'h0;
		int_carry = 1'b0;
		c_out = c_in; /* unless explicitly modified */
		case (opcode_in)
			`OP_ARITHM_ADDSAT: // add signed with saturation
				begin
					if (s_in[31] & d_in[31] & (~add_o[31])) // signed overflow ?
						{c_out, d_out } = 33'h1_8000_0000; // negative result
					else
						if ((~s_in[31]) & (~d_in[31]) & add_o[31])
							{ c_out, d_out } = 33'h1_7fff_ffff; // positive result
						else
							{ c_out, d_out } = add_o;
				end
			`OP_ARITHM_ADDBIN:
				{ c_out, d_out } = add_o;
			`OP_ARITHM_AND:
				d_out = s_in & d_in;
			`OP_ARITHM_OR:
				d_out = s_in | d_in;
			`OP_ARITHM_SUBSAT: // Subtract and saturate
			    begin // V = A31*/B31*/R31+/A31*B1*R31
					if (s_in[31] & (~d_in[31]) & (~sub_o[31]))
						{c_out, d_out } = 33'h1_7fff_ffff; // positive result
					else
						if ((~s_in[31]) & d_in[31] & sub_o[31])
							{ c_out, d_out } = 33'h1_8000_0000; // negative result
						else
							{ c_out, d_out } = sub_o;
				end
			`OP_ARITHM_SUBBIN:
				{ c_out, d_out } = { 1'b0, d_in } - { 1'b0, s_in };
			`OP_ARITHM_NOT:
				d_out = ~s_in;
			`OP_ARITHM_MULS:
				begin
				  /* handled in the sequencer */
				end
			`OP_ARITHM_ADCBIN:
				{ c_out, d_out } = { 1'b0, d_in } + { 1'b0, s_in } + { 32'h0, c_in };
			`OP_ARITHM_NAND:
				d_out = d_in & (~s_in);
			`OP_ARITHM_XOR:
				d_out = s_in ^ d_in;
			`OP_ARITHM_SBCBIN:
				{ c_out, d_out } = { 1'b0, d_in } - { 1'b0, s_in } - { 32'h0, c_in };
			`OP_ARITHM_MOV:
				d_out = s_in;
			`OP_ARITHM_MUL:
				d_out = s_in[7:0] * d_in[7:0];
			`OP_ARITHM_SHL:
				{ c_out, d_out } = { s_in, 1'b0 };
			`OP_ARITHM_SHR:
				begin
					c_out = s_in[0];
					d_out = { 1'b0, s_in[31:1] };
				end
			`OP_ARITHM_ROL:
				begin
					c_out = s_in[31];
					d_out = { s_in[30:0], c_in };
				end
			`OP_ARITHM_ROR:
				begin
					c_out = s_in[0];
					d_out = { c_in, s_in[31:1] };
				end
			`OP_ARITHM_ASR: // arithmetic shift right
				begin
					c_out = s_in[0];
					d_out = { s_in[31], s_in[31:1] };
				end
			`OP_ARITHM_MOV8SX: // move and sign extension
				if (s_in[7] == 1'b0)
					d_out = { 24'h0, s_in }; 
				else
					d_out = { 24'h0, s_in }; 
			`OP_ARITHM_MOV16SX: // move and sign extension
				if (s_in[15] == 1'b0)
					d_out = { 16'h0, s_in }; 
				else
					d_out = { 16'h1, s_in }; 
			`OP_ARITHM_SHR16: // move right 16 places
				d_out = { 16'h0, s_in[31:16] }; 
			`OP_JUMP_DJNZ:
				d_out = d_in - 1;
			`OP_JUMP_TJNZ,
			`OP_JUMP_TJZ:
				z_out = d_in == 32'h0;
		endcase
	end

endmodule

`endif

/*
                            TERMS OF USE: MIT License

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
*/